// HitTesterView.h : interface of the CHitTesterView class
//

#include "HCNObject.h"

#pragma once


class CHitTesterView : public CView
{
protected: // create from serialization only
	CHitTesterView();
	DECLARE_DYNCREATE(CHitTesterView)

// Attributes
public:
	CHitTesterDoc* GetDocument() const;

// Operations
public:
	/////////////////// DRAWING /////////////////////
	CPoint m_pt1;
	CPoint m_pt2;

	Bitmap* m_Bitmap;
	REAL m_rStrokeWidth;
	Color m_colorStroke;

	// Flags
	BOOL m_bDrawBegin;
	BOOL m_bDrawMode;
	BOOL m_bDrawLine;
	BOOL m_bDrawCurve;

	BOOL m_bSelectMode;
	BOOL m_bSelectNode;
	BOOL m_bSelectSegment;

	BOOL m_bShowNode;

	CHCN_ObjectArray*	m_obArray;			
	CHCN_ObjectArray*	m_ptArray;

	void CancelDrawingMode();
	void AddObjectLine();
	void AddPointToArray(CPoint &point);
	int GetEncoderClsid(const WCHAR* format, CLSID* pClsid);

// Overrides
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);

// Implementation
public:
	virtual ~CHitTesterView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnLineCurved();
	afx_msg void OnUpdateLineCurved(CCmdUI *pCmdUI);
	afx_msg void OnLineStraight();
	afx_msg void OnUpdateLineStraight(CCmdUI *pCmdUI);
	afx_msg void OnSelectNode();
	afx_msg void OnUpdateSelectNode(CCmdUI *pCmdUI);
	afx_msg void OnSelectSegment();
	afx_msg void OnUpdateSelectSegment(CCmdUI *pCmdUI);
	afx_msg void OnViewShownode();
	afx_msg void OnUpdateViewShownode(CCmdUI *pCmdUI);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnDrawDelete();
	afx_msg void OnUpdateDrawDelete(CCmdUI *pCmdUI);
	int CountSelectedObject(void);
	afx_msg void OnFileSave();
};

#ifndef _DEBUG  // debug version in HitTesterView.cpp
inline CHitTesterDoc* CHitTesterView::GetDocument() const
   { return reinterpret_cast<CHitTesterDoc*>(m_pDocument); }
#endif

